{$A-,B-,D+,E+,F-,G-,I-,L+,N-,O-,R-,S-,V-,X+}
{۲}
{                 Digital music packing routines.                  ۲}
{             Developed in 1992 by FRIENDS software                ۲}
{                       Free for spreading                         ۲}
{ Version      : 1.0                                               ۲}
{ Last release : 10/06/92                                          ۲}
{۲}

Unit LZHSTM;

Interface
Uses Dos;

const
     MaxFreq     = $0980;           (*   Updating tree frequence   ۲*)
     NumSymbols  = 48;              (* Number of chars for len enc.۲*)
     MaxMatchLen = NumSymbols+255;  (*     Some constants for      ۲*)
     NChars      = 254+NumSymbols;  (*   dynamic Huffman coding    ۲*)
     Root        = NChars*2-2;      (*  and Lempel-Ziv algorythm   ۲*)
     OutBufLength= 512;             (*     Output buffer length    ۲*)
     RingBufSize = 8192+MaxMatchLen;(*       Ring buffer size      ۲*)

type LongRec     = record
                    LoWord,HiWord : Word;
                   end;
     ArOfByte    = array[0..$FFF0] of byte;
     RingBuf     = array[0..RingBufSize-1] of byte;

var  CharFreq,Son    : array[0..NChars*2-2]  of Word;
     Dad             : array[0..NChars*3-1]  of Word;
     OVar            : LongInt;
     LR              : LongRec absolute OVar;
     WorkFile        : File;
     Data            : ^ArOfByte;
     RingBuffer,DecompBuff
                     : ^RingBuf;
     OutBuf          : array[0..OutBufLength-1] of byte;
     OutWordBuf,CodeSize,OutBufPos,
     RingPos,EndPos,InPos,MatchPos,
     MatchLength,i,j,k,l,
     CurNode         : Word;
     OutWordPos,
     InBytePos,InByteBuf,
     FirstChar       : Byte;
     Chain           : array[0..8191+MaxMatchLen] of Word;
     ChainBegin      : array[0..255] of Word;
     H,M,S,H1,M1,S1,S2,S11
                     : Word;

     Function  InitDecompression : Boolean;
     Function  InitCompression : Boolean;
     Procedure EndProcess;
     Procedure DecompressBlock(var Where; CompSize,UncompSize : Word);
     Procedure CompressBlock  (var Where; HowMany : Word);
     Procedure FlushOutBuffer;
     Procedure FlushInputBuffer; InLine($C6/$06/InBytePos/$00);

Implementation

Procedure InitBuffer; assembler;
asm   xor  ax,ax
      mov  OutWordBuf,ax
      mov  OutBufPos ,ax
      mov  OutWordPos,al
end;

procedure LZInit; assembler;
asm   lea  di,Chain
      mov  cx,8192+MaxMatchLen+256
      mov  ax,$FFFF
      cld
      push ds
      pop  es
      rep  stosw
end;

procedure LZReloc;
var jj : word;
begin
 i:=RingPos-4096;
 for jj:=0 to 255 do
     begin
      if ChainBegin[jj]<i
         then ChainBegin[jj]:=$FFFF
         else if ChainBegin[jj]<>$FFFF
                 then Dec(ChainBegin[jj],i);
     end;
 Move(Chain[i],Chain[0],(RingBufSize-i)*2);
 for jj:=0 to 4095 do
     if Chain[jj]<>$FFFF
        then if Chain[jj]>=i
                then Dec(Chain[jj],i)
                else Chain[jj]:=$FFFF;
 asm lea di,Chain[4096*2]
     mov cx,RingBufSize-4096
     mov ax,$FFFF
     cld
     rep stosw
 end;
end;

procedure AddInChain;
var jj : Word;
begin
  for i:=RingPos+1 to RingPos+MatchLength-1 do
      begin
       jj:=RingBuffer^[i];
       Chain[i]:=ChainBegin[jj];
       ChainBegin[jj]:=i;
      end;
end;

Procedure OutByte(b : Byte);
begin
 OutBuf[OutBufPos]:=b;
 Inc(OutBufPos);Inc(CodeSize);
 if OutBufPos=OutBufLength
    then begin
          BlockWrite(WorkFile,OutBuf,OutBufLength);
          OutBufPos:=0;
         end;
end;

Procedure FlushOutBuffer;
begin
 if OutWordPos>0 then
    begin
     OutBuf[OutBufPos]:=OutWordBuf shr 8;
     OutWordPos:=0;Inc(OutBufPos);Inc(CodeSize);
    end;
 BlockWrite(WorkFile,OutBuf,OutBufPos);
 OutBufPos:=0;OutWordBuf:=0;
end;

Procedure OutBits(w : Word; Num : Byte);
begin
 w:=w shl (16-Num);
 OutWordBuf:=OutWordBuf or (w shr OutWordPos);
 OutWordPos:=OutWordPos+Num;
 if (OutWordPos>7) then
    begin
     OutByte(OutWordBuf shr 8);
     Dec(OutWordPos,8);
     if (OutWordPos>7)
        then begin
              OutByte(OutWordBuf);
              Dec(OutWordPos,8);
              OutWordBuf:=w shl (Num-OutWordPos);
             end
        else OutWordBuf:=OutWordBuf shl 8;
    end;
end;

Function GetBit : Byte;
begin
 if InBytePos=0 then
    asm les  di,RingBuffer
        add  di,RingPos
        mov  al,byte ptr es:[di]
        mov  InByteBuf,al
        mov  InBytePos,8
        inc  RingPos
    end;
 GetBit:=InByteBuf shr 7;
 InByteBuf:=InByteBuf shl 1;
 Dec(InBytePos);
end;

Function GetPosition : Word;
var i : Word;
    j : Byte;
begin
 i:=0;
 for j:=0 to 11 do i:=(i shl 1) or GetBit;
 GetPosition:=i+1;
end;

Function GetLen : Word;
var i : Word;
    j : Byte;
begin
 i:=0;
 for j:=0 to 7 do i:=(i shl 1) or GetBit;
 GetLen:=i;
end;

Procedure HuffmanInit;
begin
 asm  lea  di,CharFreq
      mov  cx,NChars
      mov  ax,1
      cld
      push ds
      pop  es
      rep  stosw
      xor  ax,ax
      mov  i,ax
      mov  word ptr Dad[Root*2],ax
 end;
 for j:=NChars to NChars*2-1 do
     begin
      if j<=Root then
         begin
          CharFreq[j]:=CharFreq[i]+CharFreq[i+1];
          Son[j]:=i;
          Dad[i]:=j;Dad[i+1]:=j;
         end;
      Son[j-NChars]:=j+NChars;
      Dad[j+NChars]:=j-NChars;
      Inc(i,2);
     end;
end;

procedure ReconstructTree;
Var i,j,k : integer;
    ff,l  : word;
begin
 j:= 0;
 for i:=0 to NChars*2-2 do
     if (Son[i]>=NChars*2) then
        begin
         CharFreq[j]:=(CharFreq[i]+1) shr 1;
         son[j]:=son[i];Inc(j);
        end;
 {* begin constructing tree by connecting sons *}
 i:=0;
 for j:=NChars to NChars*2-2 do
     begin
      k:=i+1;
      CharFreq[j]:=CharFreq[i]+CharFreq[k];
      ff:=CharFreq[j];
      k:=j-1;
      While(ff<CharFreq[k]) do dec(k);
      Inc(k);
      l:=(j-k) shl 1;
      Move(CharFreq[k],CharFreq[k+1],l);
      CharFreq[k]:=ff;
      Move(son[k],son[k+1],l);
      Son[k]:=i;Inc(i,2);
     end;
 {* connect parents *}
 for i:=0 to NChars*2-2 do
     begin
      k:=son[i];Dad[k]:=i;
      if k<NChars*2-1 then Dad[k+1]:=i;
     end;
end;

procedure IncFreq(Ch : Word);
begin
 if CharFreq[Root]=MaxFreq then ReconstructTree;
 Ch:=Dad[Ch+NChars*2];
 repeat
  Inc(CharFreq[Ch]);i:=CharFreq[Ch];
  if i>CharFreq[Ch+1] then
     begin
      CurNode:=Ch+2;
      While CharFreq[CurNode]<i do Inc(CurNode);
      Dec(CurNode);CharFreq[Ch]:=CharFreq[CurNode];
      CharFreq[CurNode]:=i;
      i:=Son[Ch];Dad[i]:=CurNode;
      if i<Root then Dad[i+1]:=CurNode;
      j:=Son[CurNode];Son[CurNode]:=i;
      Son[Ch]:=j;Dad[j]:=Ch;
      if j<Root then Dad[j+1]:=Ch;
      Ch:=CurNode;
     end;
  Ch:=Dad[Ch];
 until Dad[Ch]=0;
 Inc(CharFreq[Root]);
end;

procedure HufOutChar(Ch : Word);
begin
 CurNode:=Dad[Ch+NChars*2];OVar:=0;i:=0;
 repeat
  OVar:=(OVar shr 1);Inc(i);
  if boolean(CurNode and 1) then OVar:=OVar or $80000000;
  CurNode:=Dad[CurNode];
 until CurNode=Root;
 OVar:=OVar shr (32-i);
 if i>16 then begin OutBits(LR.HiWord,i-16);i:=16;end;
 OutBits(LR.LoWord,i);
 IncFreq(Ch);
end;

Function HufInputChar : Word;
var c : Word;
begin
 c:=Son[Root];
 While c<=Root do c:=Son[c+GetBit];
 c:=c-Root-2;
 IncFreq(c); HufInputChar:=c;
end;

Function Search : Boolean;
label EndSearch;
var LowerPos : Word;
begin
 FirstChar:=RingBuffer^[RingPos];
 i:=ChainBegin[FirstChar];l:=0;LowerPos:=RingPos-4096;
 MatchLength:=1;MatchPos:=$FFFF;
 While (i<>$FFFF) and (i>=LowerPos) do
       begin
        j:=1;Inc(l);
        While (RingBuffer^[RingPos+j]=RingBuffer^[i+j])
              and (j<MaxMatchLen) and (RingPos+j<EndPos) do Inc(j);
        if (j>2) and (j>MatchLength) then
           begin
            MatchPos:=RingPos-i;MatchLength:=j;
            if MatchLength=MaxMatchLen
               then GoTo EndSearch;
           end;
        i:=Chain[i];
       end;
EndSearch:
 if (MatchPos<>$FFFF) and (l>0)
    then Search:=True
    else Search:=False;
 Chain[RingPos]:=ChainBegin[FirstChar];
 ChainBegin[FirstChar]:=RingPos;
end;

Procedure CompressBlock;
var i : Word;
begin
 Data:=@Where;InPos:=0;CodeSize:=0;
 if HowMany=0 then Exit;
 if (EndPos<RingBufSize) then
    begin
     i:=RingBufSize-EndPos;if i>HowMany then i:=HowMany;
     Move(Data^[0],RingBuffer^[EndPos],i);
     Dec(HowMany,i);Inc(EndPos,i);InPos:=i;
    end;
 repeat
 { Check if need to load next data block ۲}
  if (EndPos<RingPos+MaxMatchLen) and (HowMany>0) then
     begin
      LZReloc;i:=RingPos-4096;
      Move(RingBuffer^[i],RingBuffer^[0],RingBufSize-i);
      Dec(EndPos,i);RingPos:=4096;
      i:=RingBufSize-EndPos;if i>HowMany then i:=HowMany;
      Move(Data^[InPos],RingBuffer^[EndPos],i);
      Dec(HowMany,i);Inc(EndPos,i);Inc(InPos,i);
     end;
 { Search for matching string ۲}
    if Search then begin
                    if MatchLength<NumSymbols
                       then HufOutChar(253+MatchLength)
                       else begin
                             HufOutChar(253+NumSymbols);
                             OutBits(MatchLength-NumSymbols,8);
                            end;
                    OutBits(MatchPos-1,12);
                    AddInChain;
                    Inc(RingPos,MatchLength);
                   end
              else begin
                    HufOutChar(FirstChar);
                    Inc(RingPos);
                   end;
 until RingPos>=EndPos;
end;

Procedure DecompressBlock;
var i,StartOfs,OutOfs : Word;
begin
 Data:=@Where;InPos:=0;CodeSize:=0;
 StartOfs:=OutBufPos;OutOfs:=0;
 RingPos:=EndPos;
 if CompSize=0 then Exit;
 if (EndPos<RingBufSize) then
    begin
     i:=RingBufSize-EndPos;if i>CompSize then i:=CompSize;
     BlockRead(WorkFile,RingBuffer^[EndPos],i);
     Inc(EndPos,i);InPos:=i;Dec(CompSize,i);
    end;
 repeat
 { Check if need to load next data block ۲}
  if (EndPos<RingPos+16) and (CompSize>0) then
     begin
      Move(RingBuffer^[RingPos],RingBuffer^[0],EndPos-RingPos);
      Dec(EndPos,RingPos);RingPos:=0;
      i:=RingBufSize-EndPos;if i>CompSize then i:=CompSize;
      BlockRead(WorkFile,RingBuffer^[EndPos],i);
      Inc(EndPos,i);Inc(InPos,i);Dec(CompSize,i);
     end;
 { Check for decompress buffer overflow ۲}
  if OutBufPos>RingBufSize-MaxMatchLen then
     begin
      i:=OutBufPos-4096;
      if StartOfs<i then
         begin
          Move(DecompBuff^[StartOfs],Data^[OutOfs],i-StartOfs);
          Inc(OutOfs,i-StartOfs);StartOfs:=i;
         end;
      Move(DecompBuff^[i],DecompBuff^[0],4096);
      OutBufPos:=4096;Dec(StartOfs,i);
     end;
 { Read next char from input stream ۲}
  i:=HufInputChar;
  if i<256 then begin
                 DecompBuff^[OutBufPos]:=i;
                 Inc(OutBufPos);Inc(CodeSize);
                end
           else begin
                 if i=NChars-1 then i:=253+NumSymbols+GetLen;
                 MatchLength:=i-253;
                 MatchPos:=GetPosition;
                 for i:=1 to MatchLength do
                     begin
                      DecompBuff^[OutBufPos]:=DecompBuff^[OutBufPos-MatchPos];
                      Inc(OutBufPos);
                     end;
                 Inc(CodeSize,MatchLength);
                end;
 until CodeSize>=UncompSize;
 InOutRes:=0;
 Move(DecompBuff^[StartOfs],Data^[OutOfs],OutBufPos-StartOfs);
end;

Function InitCompression;
begin
 InitCompression:=False;
 if RingBuffer=NIL then New(RingBuffer);
 if RingBuffer=NIL then Exit;
 HuffmanInit;InitBuffer;LZInit;
 RingPos:=4096;EndPos:=4096;
 FillChar(RingBuffer^[0],4096,0);
 InitCompression:=True;
end;

Function InitDecompression;
begin
 InitDecompression:=False;
 if RingBuffer=NIL then New(RingBuffer);
 if RingBuffer=NIL then Exit;
 if DecompBuff=NIL then New(DecompBuff);
 if DecompBuff=NIL then begin EndProcess;Exit; end;
 HuffmanInit;LZInit;
 EndPos:=0;OutBufPos:=4096;FlushInputBuffer;
 InitDecompression:=True;
end;

Procedure EndProcess;
begin
 if RingBuffer<>NIL then Dispose(RingBuffer);
 if DecompBuff<>NIL then Dispose(DecompBuff);
 RingBuffer:=NIL;DecompBuff:=NIL;
end;

begin
 RingBuffer:=NIL;DecompBuff:=NIL;
end.
